package piramide;

import javax.media.opengl.GL2;
import javax.media.opengl.GLAutoDrawable;
import javax.media.opengl.GLEventListener;

public class GLRenderer implements GLEventListener {

	int a = 0;

	@Override
	public void init(GLAutoDrawable drawable) {
		GL2 gl = drawable.getGL().getGL2();

		// attiva il test di profondit per disegnare solo le parti visibili
		gl.glEnable(GL2.GL_DEPTH_TEST);
	}

	@Override
	public void dispose(GLAutoDrawable drawable) {
	}

	@Override
	public void display(GLAutoDrawable drawable) {
		GL2 gl = drawable.getGL().getGL2();

		// cancella l'immagine e il buffer per il test di profondit
		gl.glClear(GL2.GL_COLOR_BUFFER_BIT | GL2.GL_DEPTH_BUFFER_BIT);

		gl.glLoadIdentity();
		gl.glRotatef(10, 0, 0, 1);		// rotazione fissa di 10 intorno a Z
		gl.glRotatef(a, 1, 0, 0);		// rotazione variabile di a intorno a X

		// la base della piramide  blu, ma il 4 vertice  pi scuro
		gl.glBegin(GL2.GL_QUADS);
		gl.glColor3d(0, 0, 1);
		gl.glVertex3d(1, 1, 0);
		gl.glVertex3d(-1, 1, 0);
		gl.glVertex3d(-1, -1, 0);
		gl.glColor3d(0, 0, 0.1);
		gl.glVertex3d(1, -1, 0);
		gl.glEnd();

		// la 1 faccia  rossa, ma il 3 vertice  pi scuro
		gl.glBegin(GL2.GL_TRIANGLES);
		gl.glColor3d(1, 0, 0);
		gl.glVertex3d(0, 0, 1);
		gl.glVertex3d(1, 1, 0);
		gl.glColor3d(0.1, 0, 0);
		gl.glVertex3d(-1, 1, 0);
		gl.glEnd();

		// la 2 faccia  verde, ma il 3 vertice  pi scuro
		gl.glBegin(GL2.GL_TRIANGLES);
		gl.glColor3d(0, 1, 0);
		gl.glVertex3d(0, 0, 1);
		gl.glVertex3d(-1, 1, 0);
		gl.glColor3d(0, 0.1, 0);
		gl.glVertex3d(-1, -1, 0);
		gl.glEnd();

		// la 3 faccia  magenta, ma il 3 vertice  pi scuro
		gl.glBegin(GL2.GL_TRIANGLES);
		gl.glColor3d(1, 0, 1);
		gl.glVertex3d(0, 0, 1);
		gl.glVertex3d(-1, -1, 0);
		gl.glColor3d(0.1, 0, 0.1);
		gl.glVertex3d(1, -1, 0);
		gl.glEnd();

		// la 4 faccia  gialla, ma il 3 vertice  pi scuro
		gl.glBegin(GL2.GL_TRIANGLES);
		gl.glColor3d(1, 1, 0);
		gl.glVertex3d(0, 0, 1);
		gl.glVertex3d(1, -1, 0);
		gl.glColor3d(0.1, 0.1, 0);
		gl.glVertex3d(1, 1, 0);
		gl.glEnd();

		a++;
	}

	@Override
	public void reshape(GLAutoDrawable drawable, int x, int y, int w, int h) {
		GL2 gl = drawable.getGL().getGL2();

		// imposta la matrice di trasformazione per la proiezione
		gl.glMatrixMode(GL2.GL_PROJECTION);
		gl.glLoadIdentity();
		gl.glOrtho(-2.0 * w / h, 2.0 * w / h, -2.0, 2.0, -2.0, 2.0);

		// imposta la matrice di trasformazione per gli oggetti
		gl.glMatrixMode(GL2.GL_MODELVIEW);
		gl.glLoadIdentity();
	}

}
