package piramide;

import java.awt.EventQueue;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.media.opengl.GLCapabilities;
import javax.media.opengl.GLProfile;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JToggleButton;

import com.jogamp.newt.opengl.GLWindow;
import com.jogamp.opengl.util.FPSAnimator;

public class Main extends JFrame {

	GLWindow window;
	FPSAnimator animator;
	GLRenderer renderer;

	public Main() {
		// OpenGL
		window = GLWindow.create(new GLCapabilities(GLProfile.getDefault()));	// crea la finestra di rendering
		window.setTitle("OpenGL - GLWindow");									// imposta il titolo
		window.setSize(800, 600);												// imposta la dimensione
		renderer = new GLRenderer();											// istanzia la classe GLRenderer
		window.addGLEventListener(renderer); 									// passa all'ascolatore di eventi l'oggetto renderer
		animator = new FPSAnimator(window, 60, false);							// istanzia la classe FPSAnimator, 60  la frequenza di rendering

		setTitle("OpenGL");
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(0, 0, 392, 74);
		JPanel contentPane = new JPanel();
		contentPane.setLayout(new FlowLayout(FlowLayout.LEFT, 6, 6));
		setContentPane(contentPane);

		JButton btnShow = new JButton("Show");
		btnShow.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				window.setVisible(true);
			}
		});
		contentPane.add(btnShow);

		JButton btnHide = new JButton("Hide");
		btnHide.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				window.setVisible(false);
			}
		});
		contentPane.add(btnHide);

		JToggleButton btnFullscreen = new JToggleButton("Fullscreen");
		btnFullscreen.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				window.setFullscreen(btnFullscreen.isSelected());
			}
		});
		contentPane.add(btnFullscreen);

		JButton btnStart = new JButton("Start");
		btnStart.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				animator.start();
			}
		});
		contentPane.add(btnStart);

		JButton btnStop = new JButton("Stop");
		btnStop.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				animator.stop();
			}
		});
		contentPane.add(btnStop);
	}

	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					Main frame = new Main();
					frame.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}
}
